﻿var app = window.app = window.app || {};
app.vm = app.vm || {};

app.vm.Docs = function () {
    var self = this;
    //var mmanager = new breeze.EntityManager(app.root + 'api/OpenData/');
    self.Sections = ko.observableArray([]);
    self.AllSections = ko.observableArray();
    self.lastSection = ko.observableArray([]);
    self.activeSection = ko.observable({ Id: ko.observable(null), Name: 'Основные разделы' });
    self.activeSection.subscribe(function () {
        self.loadDocsSection();
        self.loadDocuments();
    });
    self.headSection = ko.observableArray();
    self.newDocument = ko.observable({
        Caption: ko.observable(''),
        DateAdd: ko.observable(new Date()),
        SectionId: ko.observable(0),
        Extention: ko.observable('')
    });
    self.editType = ko.observable();
    self.showName = ko.observable(true);
    self.documents = ko.observableArray();
    self.sortDocument = function (r, l) {
        if (self.documents().length > 0) {
            switch (self.activeOrderCol()) {
                case 'Name':
                    if (self.sortOrder() == 'ASC')
                        return r.Caption().toLowerCase() > l.Caption().toLowerCase() ? 1 : -1;
                    else
                        return r.Caption().toLowerCase() < l.Caption().toLowerCase() ? 1 : -1;
                case 'Date':
                    if (self.sortOrder() == 'ASC')
                        return r.DateAdd() > l.DateAdd() ? 1 : -1;
                    else
                        return r.DateAdd() < l.DateAdd() ? 1 : -1;
                default:
                    return r.Caption().toLowerCase() < l.Caption().toLowerCase() ? 1 : -1;
            }
        }
        return true;
    };
    self.sortSection = function (r, l) {
        if (self.Sections().length > 0) {
            switch (self.activeOrderCol()) {
                case 'Name':
                    if (self.sortOrder() == 'ASC')
                        return r.Name().toLowerCase() > l.Name().toLowerCase() ? 1 : -1;
                    else
                        return r.Name().toLowerCase() < l.Name().toLowerCase() ? 1 : -1;
                case 'Date':
                    if (self.sortOrder() == 'ASC')
                        return r.DateAdd() > l.DateAdd() ? 1 : -1;
                    else
                        return r.DateAdd() < l.DateAdd() ? 1 : -1;
                default:
                    return r.Name().toLowerCase() < l.Name().toLowerCase() ? 1 : -1;
            }
        }
        return true;
    };
    self.isEditableDocument = ko.observable();
    self.isEditableFolder = ko.observable();
    self.searchStr = ko.observable('');
    self.searchStr.subscribe(function () {
        if (self.searchStr().length != 0) {
            if (self.activeSection().Id() != -1) {
                self.lastSection.push(self.activeSection());
                self.activeSection({ Id: ko.observable(-1), Name: 'Результаты поиска' });
            }
            self.loadDocuments();
        } else {
            if (self.activeSection().Id() == -1) {
                self.activeSection(self.lastSection()[self.lastSection().length - 1]);
                self.lastSection.pop();
            }
        }
    });
    self.orderColumns = ko.observableArray([
        { Id: 'Name', Name: 'Названию документа' },
        { Id: 'Date', Name: 'Дате добавления' }
    ]);
    self.activeOrderCol = ko.observable('Date');
    self.activeOrderCol.subscribe(function () {
        //self.loadDocuments();
    });
    self.sortOrder = ko.observable('DESC');
    self.toggleSorting = function () {
        self.sortOrder(self.sortOrder() == 'ASC' ? 'DESC' : 'ASC');
    };
    self.addedObj = ko.observable(null);

    self.loading = ko.observable(false);
    self.readOnly = ko.observable(true);

    self.detailsEnabled = ko.observable(null);
    self.enableDetails = function (entity) {
        self.detailsEnabled(entity);
    };
    self.disableDetails = function (id) {
        self.detailsEnabled(null);
    };

    self.count = ko.computed(function () {
        return self.Sections().length + self.documents().length;
    });
    self.width = ko.computed(function () {
        //return self.count() < 2 && self.count() >= 1 ? Math.floor(982 / self.count()) - 22 : 305;
        return 982 / 2 - 22;
    });

    self.getNameSectionById = function (id) {
        return $.map(self.Sections(), function (st) { return st.Id != null && st.Id == id ? st.Name : null; })[0];
    };

    self.GetImage = function (ext) {
        switch (ext()) {
            case '.xls':
                return app.root + 'Content/img/icons/setData.png';
            case '.doc':
                return app.root + 'Content/img/icons/setData.png';
            case '.xlsx':
                return app.root + 'Content/img/icons/setData.png';
            case '.docx':
                return app.root + 'Content/img/icons/setData.png';
            case '.pdf':
                return app.root + 'Content/img/icons/presentation.png';
            case '.ppt':
                return app.root + 'Content/img/icons/presentation.png';
            case '.pptx':
                return app.root + 'Content/img/icons/presentation.png';
            default:
                return app.root + 'Content/img/icons/reglament.png';

        }
    };

    var old = { caption: '', sectionId: '' };
    self.EditDocument = function (Entity, type) {
        if (self.isEditableDocument() == null) {
            self.isEditableDocument(Entity.Id());
            old.caption = Entity.Caption();
            old.sectionId = Entity.SectionId();
            self.editType(type);
        } else {
            if (self.isEditableDocument() == Entity.Id()) {
                if (self.editType() == 'Caption') {
                    if (Entity.Caption() != "") {
                        $.ajax({
                            type: 'POST',
                            contentType: "application/json; charset=utf-8",
                            url: app.root + "Cabinet/Docs/UpdateDocument/",
                            data: JSON.stringify({ Id: Entity.Id(), caption: Entity.Caption() }),
                            dataType: "json",
                            success: function (results) {
                                //console.log(results);

                            }
                        });
                    }
                } else {
                    $.ajax({
                        type: 'POST',
                        contentType: "application/json; charset=utf-8",
                        url: app.root + "Cabinet/Docs/UpdateDocumentSection/",
                        data: JSON.stringify({ Id: Entity.Id(), section: Entity.SectionId() }),
                        dataType: "json",
                        success: function (results) {
                            //console.log(results);
                            self.loadDocuments();
                        }
                    });

                }
                self.isEditableDocument(null);
                self.editType(null);
            }
        }
    };


    var oldFolder = { caption: '' };
    self.EditFolder = function (Entity) {
        if (self.isEditableFolder() == null) {
            self.isEditableFolder(Entity.Id());
            oldFolder.caption = Entity.Name();
        } else {
            if (self.isEditableFolder() == Entity.Id()) {
                if (Entity.Name() != "") {
                    $.ajax({
                        type: 'POST',
                        contentType: "application/json; charset=utf-8",
                        url: app.root + "Cabinet/Docs/UpdateSection/",
                        data: JSON.stringify({ Id: Entity.Id(), caption: Entity.Name() }),
                        dataType: "json",
                        success: function (results) {
                            //console.log(results);
                        }
                    });
                }
                self.isEditableFolder(null);;
            }
        }
    };



    self.preRemoveDocument = function (Entity) {
        if (self.isEditableDocument() == Entity.Id()) {
            Entity.Caption(old.caption);
            Entity.SectionId(old.sectionId);
            self.isEditableDocument(null);
            self.editType(null);
        } else {
            if (confirm("вы уверены, что хотите удалить файл? ")) {
                $.ajax(
                {
                    type: 'GET',
                    contentType: "application/json; charset=utf-8",
                    url: app.root + "Cabinet/Docs/DeleteDocument/?id=" + Entity.Id(),
                    dataType: "json",
                    success: function (result) {
                        self.loadDocuments();
                    }
                });
            }
        }
    };

    self.delCat = function (Entity) {
        if (self.isEditableFolder() == Entity.Id()) {
            Entity.Name(oldFolder.caption);
            self.isEditableFolder(null);
        } else {
            if (confirm("При удалении каталога, все вложенные файлы будут удалены. Вы уверены что хотите удалить каталог?")) {
                $.ajax(
                    {
                        type: 'GET',
                        contentType: "application/json; charset=utf-8",
                        url: app.root + "Cabinet/Docs/DeleteSection/?id=" + Entity.Id(),
                        dataType: "json",
                        success: function (result) {
                            self.loadDocsSection();
                        }
                    });
            }
        }
    };


    self.saveNewCat = function () {
        $.ajax({
            type: 'POST',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Cabinet/Docs/AddCategory/",
            data: JSON.stringify({ caption: self.newDocument().Caption(), sectionId: self.activeSection().Id() }),
            dataType: "json",
            success: function (results) {
                //console.log(results);
                self.loadDocsSection();
            }
        });
        self.resetNewDocs();

    };

    self.resetNewDocs = function () {
        self.newDocument().Caption('');
        self.newDocument().DateAdd(new Date());
        self.newDocument().SectionId(undefined);
        self.addedObj(null);
    };

    self.downloadMaterial = function (Id) {
        $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Cabinet/Docs/downloadMaterial/?id=" + Id(),
            dataType: "json",
            success: function (result) {
            }
        });
    };

    self.getIndexParent = function () {
        $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Documents/GetSectionIdForParent/?sectionId=" + self.activeSection().Id(),
            dataType: "json",
            success: function (result) {
                //console.log(result);
            }
        });
    };


    var predicate = breeze.Predicate;
    self.createPredicate = function () {
        var DocName = "indexOf(toLower(Caption), '" + self.searchStr().toLocaleLowerCase() + "')";
        //var Ext = "indexOf(toLower(Extention), '" + self.searchStrDocExt().toLowerCase() + "')";
        var p1, p2;
        if (self.searchStr().length != 0) {
            var parents = self.getIndexParent();
            p1 = predicate.create(DocName, ">=", 0);
            if (self.activeSection().Id() == -1) {
                return p1;
            } else {
                p2 = predicate.create("SectionId", "==", self.activeSection().Id());
                return p1.and(p2);
            }
        } else {
            p1 = predicate.create(DocName, "<=", 0);
            p2 = predicate.create("SectionId", "==", self.activeSection().Id());
            return p1.and(p2);
        }
        //if (self.searchStrDocExt().length != 0) {
        //    p2 = predicate.create(Ext, ">=", 0);
        //} else {
        //    p2 = predicate.create(Ext, "<=", 0);
        //}
    };

    self.loadAllSections = function () {
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Documents/GetAllSections",
            dataType: "json",
            success: function (result) {
                var arr = [];
                for (var key in result) {
                    arr.push({Id: key, Name: result[key]});
                }
                self.AllSections(arr);
            }
        });
        //var manager = new breeze.EntityManager(app.root + 'api/OpenData/');
        //var query = new breeze.EntityQuery().select("Id, Name").from("DocsSections").orderBy("Name");
        //return manager.executeQuery(query).then(function (data) {
        //    self.AllSections(data.results);
        //    //self.AllSections.unshift({ Id: null, Name: 'Корневой каталог' });
        //    // $.map(self.Sections(), function (sec) { return sec.Name = ko.observable(sec.Name); });
        //}).fail(function (e) {
        //    //console.log(e);
        //});
    };


    self.loadDocuments = function () {
        //console.log("Загрузка документов начата");
        self.isEditableDocument(null);
        self.loading(true);
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Documents/GetDocuments",
            data: {sectionId: self.activeSection().Id()},
            dataType: "json",
            success: function (result) {
                var arr = [];
                for (var i = 0; i < result.length; i++) {
                    arr.push({
                        Id: ko.observable(result[i].Id),
                        DateAdd: ko.observable(result[i].Date),
                        Extention: ko.observable(result[i].Extention),
                        Caption: ko.observable(result[i].Caption),
                        Name: ko.observable(result[i].Name),
                        SectionId: ko.observable(result[i].SectionId)
                    });
                }
                self.documents(arr);
                self.loading(false);
            }
        });
        //var pred = self.createPredicate();
        //var query = new breeze.EntityQuery().from("Materials").where(pred).orderBy(self.activeOrderCol());
        //return mmanager.executeQuery(query).then(function (data) {
        //    //console.log(data);
        //    self.documents(data.results);
        //    self.loading(false);
        //}).fail(function (e) {
        //    //console.log(e);
        //});
    };


    self.loadDocsSection = function () {
        return $.ajax({
            type: 'GET',
            contentType: "application/json; charset=utf-8",
            url: app.root + "Api/Documents/GetSections",
            data: { sectionId: self.activeSection().Id() },
            dataType: "json",
            success: function (result) {
                var arr = [];
                for (var i = 0; i < result.length; i++) {
                    arr.push({
                        Id: ko.observable(result[i].Id),
                        DateAdd: ko.observable(result[i].Date),
                        Name: ko.observable(result[i].Name),
                        ParentId: ko.observable(result[i].ParentId)
                    });
                }
                self.Sections(arr);
                if (self.activeSection().Id() == null) self.headSection(arr);
                self.loading(false);
            }
        });
        //var manager = new breeze.EntityManager(app.root + 'api/OpenData/');
        //var query = new breeze.EntityQuery().from("DocsSections").where("ParentId", "==", self.activeSection().Id()).orderBy("Date desc");
        //return manager.executeQuery(query).then(function (data) {
        //    self.Sections(data.results);
        //    if (self.activeSection().Id() == null) self.headSection(data.results);
        //    // $.map(self.Sections(), function (sec) { return sec.Name = ko.observable(sec.Name); });
        //}).fail(function (e) {
        //    //console.log(e);
        //});
    };

    self.returnLast = function (entity) {
        var pos = self.lastSection().indexOf(entity);
        for (var i = (self.lastSection().length - 1) ; i >= pos; i--) {
            self.lastSection.remove(self.lastSection()[i]);
        }
        self.activeSection(entity);
    };

};

app.docs = new app.vm.Docs();